##########################################################################
#Ή̂a~b̃NX\Ɋւ铝vI
#
#x: NX\ia ~@b)s`Ŏwj
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#o
#fit:stan̏o, par:ꐔXg, prob:mxNg, 
#pim: isj̕䗦(a ~ b)
#xaste: \zx* (a ~ b)
#res: sA\c(a ~ b)
#V: N̘A֌W
#pa: is̎ӊm(a)
#pb: j̎ӊm(b)
#Up: sA\c0傫m(a ~ b)
#Um: sA\c0ȉ̊m(a ~ b)
#log_lik: ΐޓx
##########################################################################
Mu02 <- function(x,prob=c(0.025, 0.05, 0.5, 0.95, 0.975),
                 see=1234, cha=5, war=1000, ite=21000)
{
   library(rstan)
   dat <- list(a=nrow(x),b=ncol(x),x=x)
   scr <- "stan/Mu02.stan"                                    # Stant@C
   par<-c("pim","xaste","log_lik","res","V","pa","pb","Up","Um")# samplingϐ
   fit<-stan(file=scr,data=dat,pars=par,
             seed=see,chains=cha,warmup=war,iter=ite)
   ext<-extract(fit,par);
   out<-list(fit=fit,par=par,prob=prob,
             pim=ext$pim, xaste=ext$xaste,log_lik=ext$log_lik,
             res=ext$res,V=ext$V,pa=ext$pa,pb=ext$pb,Up=ext$Up,Um=ext$Um);
   class(out)<-'Mu02'
   return(invisible(out))
}
##########################################################################
#̃\bh
#
#x:NX 'Mu02'̃IuWFNg
#degits=3 : ̊ۂ
##########################################################################
print.Mu02<-function(x,degits=3)
{
   log_lik<-x$log_lik; 
   waic<- (-2)*(log(mean(exp(log_lik)))) + 2*(var(log_lik))
   print(x$fit,pars=x$par,digits_summary=degits,probs=x$prob)
   print(paste("waic=",round(waic,degits),sep=""))
   out<-list(waic=waic)
   return(invisible(out))
}  
