##########################################################################
#Ή̂Ȃ2Q̔䗦Ɋւ铝vIi22zj
#
#x: (2̃xNgAW{䗦̑傫̂Ɏw肷)
#n: xkCs(2̃xNg)
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#o
#fit:stan̏o, par:ꐔXg, prob:mxNg, 
#p: 䗦(2)
#xaste: \zx*(2)
#p_sa: 䗦̍
#p_hi: 䗦̔
#Odds: IbY(2)
#Odds_hi: IbY
#log_lik;ΐޓx
##########################################################################
Bi02 <- function(x,n,prob=c(0.025, 0.05, 0.5, 0.95, 0.975),
                 see=1234, cha=5, war=1000, ite=21000)
{
   library(rstan)
   dat <- list(x=x,n=n)
   scr <- "stan/Bi02.stan"                                     # Stant@C
   par<-c("p","xaste","p_sa","p_hi","Odds","Odds_hi","log_lik")# samplingϐ
   fit<-stan(file=scr,data=dat,pars=par,
             seed=see,chains=cha,warmup=war,iter=ite)
   ext<-extract(fit,par);
   out<-list(fit=fit,par=par,prob=prob,
             p=ext$p, xaste=ext$xaste, log_lik=ext$log_lik, p_sa=ext$p_sa, 
             p_hi=ext$p_hi,Odds=ext$Odds, Odds_hi=ext$Odds_hi);
   class(out)<-'Bi02'
   return(invisible(out))
}
##########################################################################
#̃\bh
#
#x:NX 'Bi02'̃IuWFNg
#degits=3 : ̊ۂ
#cr1=F : 䗦̍̍ŏl
#cr2=F : 䗦̔̍ŏl
#cr3=F : IbY̍ŏl
##########################################################################
print.Bi02<-function(x,degits=3,cr1=F,cr2=F,cr3=F)
{
   log_lik<-x$log_lik; p<-x$p; xaste<-x$xaste; p_sa<-x$p_sa; 
   p_hi<-x$p_hi; Odds<-x$Odds;  Odds_hi<-x$Odds_hi;
   waic<- (-2)*(log(mean(exp(log_lik)))) + 2*(var(log_lik))
   print(x$fit,pars=x$par,digits_summary=degits,probs=x$prob)
   U<-matrix(0,length(p),3)
   co<-0;lab<-NULL
   if(is.numeric(cr1)){co<- co+1;U[,co]<- ifelse(p_sa> cr1, 1, 0);
         lab<-c(lab,paste("䗦̍(",cr1,")傫",sep=""))}
   if(is.numeric(cr2)){co<- co+1;U[,co]<- ifelse(p_hi>  cr2, 1, 0);
         lab<-c(lab,paste("䗦̔䂪(",cr2,")傫",sep=""))}
   if(is.numeric(cr3)){co<- co+1;U[,co]<- ifelse(Odds_hi> cr3, 1, 0);
         lab<-c(lab,paste("IbY䂪(",cr3,")傫",sep=""))}
   if(co>0.9){
      Uc<-matrix(colMeans(as.matrix(U[,1:co])),co,1);
      rownames(Uc)<-lab
      }else{Uc<-0.0}
   print(round(Uc,degits))
   print(paste("waic=",round(waic,degits),sep=""))
   out<-list(waic=waic,Uc=Uc)
   return(invisible(out))
}  
